/**
 * BasicHTTPClient.ino
 *
 *  Created on: 24.05.2015
 *
 */

#include <Arduino.h>

#include <WiFi.h>
#include <WiFiMulti.h>

#include <HTTPClient.h>

#define USE_SERIAL Serial

WiFiMulti wifiMulti;

void setup() {

    USE_SERIAL.begin(115200);
    Serial2.begin(115200);
/*
    for(uint8_t t = 4; t > 0; t--) {
        USE_SERIAL.printf("[SETUP] WAIT %d...\n", t);
        USE_SERIAL.flush();
        delay(1000);
    }
*/
    wifiMulti.addAP("YOUID", "YouPassword");

}

//"var hq_str_sh000001=\"上证指数,3001.7616,2996.7618,2968.5174,3010.0286,2968.5174,0,0,352470970,378766618968,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2020-03-11,15:12:07,00,\";";
String payload;

//
// String Parser function
// Input: Str Source String
//        Arg1 - Output start position
//        Arg2 - Output end position
void GetNoData(int number, int *start, int *stop) {
  
  int Index=0;
  *start=0;
  *stop=0;
  // Find first '"'
  while ((Index<payload.length())&&(payload[Index]!='"'))
    {Index++;}
  // if current position is not '"', this means didn't find '"'
  if (payload[Index]!='"')  {return ;}
  // Look for the number string
  while (number>0) {
    *start=Index; *stop=Index;
    while ((Index<payload.length())&&(payload[Index]!=',')) {Index++;}
    *stop=Index;  
    Index++;
    number--;
  }     
}

void loop() {
  //USE_SERIAL.print("[HTTP] begin...\n");


    // wait for WiFi connection
    if((wifiMulti.run() == WL_CONNECTED)) {

        HTTPClient http;

        USE_SERIAL.print("[HTTP] begin...\n");
        // configure traged server and url
        //http.begin("https://www.howsmyssl.com/a/check", ca); //HTTPS
        http.begin("http://hq.sinajs.cn/list=sh000001"); //HTTP

        USE_SERIAL.print("[HTTP] GET...\n");
        // start connection and send HTTP header
        int httpCode = http.GET();

        // httpCode will be negative on error
        if(httpCode > 0) {
            // HTTP header has been send and Server response header has been handled
            USE_SERIAL.printf("[HTTP] GET... code: %d\n", httpCode);

            // file found at server
            if(httpCode == HTTP_CODE_OK) {
                payload = http.getString();
                USE_SERIAL.println(payload);
                int a,b,i;
                String CurrentHi,CurrentLow;
                long v;
                
                //时间
                GetNoData(32,&a,&b);
                for (int i=a;i<b;i++) { USE_SERIAL.print(payload[i]); } USE_SERIAL.print("\n");
               
                //A5 5A 12 82 04 0b 30 33 31 36 20 32 32 3A 32 39 3A 31 32 FF FF 
                Serial2.write(0xA5);
                Serial2.write(0x5A);
                Serial2.write(3+b-a+2);
                Serial2.write(0x82);
                Serial2.write(0x04);
                Serial2.write(0x0B);  
                for (int i=a;i<b;i++) { Serial2.write(payload[i]); } 
                Serial2.write(0xFF);
                Serial2.write(0xFF);
                
                //大盘
                GetNoData(4,&a,&b);
                for ( i=a;i<b;i++) { USE_SERIAL.print(payload[i]); } USE_SERIAL.print("\n");
                //A5 5A 0E 82 04 86 30 33 31 36 20 34 33 32 32 FF FF
                Serial2.write(0xA5);
                Serial2.write(0x5A);
                Serial2.write(3+b-a+2);
                Serial2.write(0x82);
                Serial2.write(0x04);
                Serial2.write(0x86);  
                for (int i=a;i<b;i++) { Serial2.write(payload[i]); } 
                Serial2.write(0xFF);
                Serial2.write(0xFF);
                
                //大盘整数
                for ( i=a;payload[i]!='.';i++) {CurrentHi=CurrentHi+payload[i];}
                //Serial.print(CurrentHi);Serial.print("\n");
                USE_SERIAL.print(CurrentHi.toInt());USE_SERIAL.print("\n");    
                //大盘小数
                for (i=i+1;i!=b;i++) {CurrentLow=CurrentLow+payload[i];}
                //Serial.print(CurrentHi);Serial.print("\n");
                USE_SERIAL.print(CurrentLow.toInt());USE_SERIAL.print("\n");  
                v= CurrentHi.toInt()*10000+CurrentLow.toInt();
                v=(v-27500000)/1000+200;
                USE_SERIAL.print(v);  USE_SERIAL.print("\n");  
                //A5 5A 04 84 01 00 00 
                Serial2.write(0xA5);
                Serial2.write(0x5A);
                Serial2.write(4);
                Serial2.write(0x84);
                Serial2.write(0x01);
                //Serial2.write(((CurrentHi.toInt()-2600)&0xFF00)>>8);  
                //Serial2.write((CurrentHi.toInt()-2600)&0xFF);
                Serial2.write((v>>8)&0xFF);  
                Serial2.write(v&0xFF);

            }
        } else {
            USE_SERIAL.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
        }

        http.end();
    }

    delay(5000);
}
